import { ElementRef, Renderer2 } from '@angular/core';
import { LyAccordion } from './accordion';
import { LyExpansionPanel } from './expansion-panel';
export declare class LyExpansionPanelHeader {
    readonly _accordion: LyAccordion;
    readonly _expansionPanel: LyExpansionPanel;
    /** @docs-private */
    readonly classes: import("@alyle/ui/public_api").LyClasses<(theme: import("@alyle/ui/public_api").LyStyleUtils & import("@alyle/ui/public_api").ThemeConfig & import("./accordion").ExpansionVariables, ref: import("@alyle/ui/public_api").ThemeRef) => {
        $priority: number;
        $name: string;
        $global: () => (_className: string) => string;
        root: () => import("@alyle/ui/public_api").StyleTemplate;
        panel: () => (_className: string) => string;
        panelHeader: () => (_className: string) => string;
        panelHeaderContent: (_className: string) => string;
        panelContent: (_className: string) => string;
        panelBody: (_className: string) => string;
        panelTitle: (_className: string) => string;
        panelDescription: (_className: string) => string;
        panelActionRow: (_className: string) => string;
        expanded: () => (_className: string) => string;
        disabled: (_className: string) => string;
    }>;
    constructor(el: ElementRef, renderer: Renderer2, _accordion: LyAccordion, _expansionPanel: LyExpansionPanel);
}
