import { Renderer2, ElementRef, OnInit, OnDestroy, OnChanges } from '@angular/core';
import { LySlider } from './slider';
export declare class LyTick implements OnChanges, OnInit, OnDestroy {
    private _slider;
    private _renderer;
    private _el;
    /** @docs-private */
    readonly classes: import("@alyle/ui").LyClasses<(theme: import("@alyle/ui").LyStyleUtils & import("@alyle/ui").ThemeConfig & import("./slider").LySliderVariables, ref: import("@alyle/ui").ThemeRef) => {
        $priority: number;
        root: () => (_className: string) => string;
        track: () => (_className: string) => string;
        bg: any;
        thumbContainer: (_className: string) => string;
        thumbContent: (_className: string) => string;
        thumb: (_className: string) => string;
        thumbLabel: (_className: string) => string;
        thumbLabelValue: (_className: string) => string;
        horizontal: () => (_className: string) => string;
        vertical: () => (_className: string) => string;
        marked: any;
        mark: (_className: string) => string;
        markActive: (_className: string) => string;
        tick: (_className: string) => string;
        tickActive: any;
        thumbVisible: any;
        thumbNotVisible: any;
        thumbContentFocused: any;
        sliding: any;
        disabled: (_className: string) => string;
    }>;
    private _tickActiveClass?;
    value: number;
    constructor(_slider: LySlider, _renderer: Renderer2, _el: ElementRef);
    ngOnChanges(): void;
    ngOnInit(): void;
    private _updateTick;
    ngOnDestroy(): void;
    _getHostElement(): any;
}
