import { ElementRef, Renderer2 } from '@angular/core';
import { LyTheme2, ThemeRef } from '../theme/theme2.service';
import { ThemeVariables } from '../theme/theme-config';
import { StyleRenderer } from '../minimal/renderer-style';
export declare class LyExpansionIcon {
    readonly sRenderer: StyleRenderer;
    private _theme;
    private _renderer;
    private _el;
    readonly classes: import("../theme/style").LyClasses<(theme: ThemeVariables, ref: ThemeRef) => {
        root: (_className: string) => string;
        line: (_className: string) => string;
        up: () => (_className: string) => string;
    }>;
    private _color;
    private _colorClass;
    private _up;
    set color(val: string);
    get color(): string;
    set up(val: boolean | '');
    get up(): boolean | '';
    constructor(sRenderer: StyleRenderer, _theme: LyTheme2, _renderer: Renderer2, _el: ElementRef);
    toggle(): void;
}
