import { ThemeVariables, StyleRenderer } from '@alyle/ui';
export declare const STYLES: (theme: ThemeVariables) => {
    $name: string;
    $priority: number;
    $global: (_className: string) => string;
    root: (_className: string) => string;
};
export declare class LySkeleton {
    readonly sRenderer: StyleRenderer;
    /** @docs-private */
    static readonly и = "LySkeleton";
    /** @docs-private */
    readonly classes: import("@alyle/ui").LyClasses<(theme: ThemeVariables) => {
        $name: string;
        $priority: number;
        $global: (_className: string) => string;
        root: (_className: string) => string;
    }>;
    get skeleton(): boolean;
    set skeleton(val: boolean);
    private _skeleton;
    constructor(sRenderer: StyleRenderer);
}
